import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudCtsTrackerV1Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1.html#bucket_name DataOpentelekomcloudCtsTrackerV1#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1.html#file_prefix_name DataOpentelekomcloudCtsTrackerV1#file_prefix_name}.
     *
     * @stability stable
     */
    readonly filePrefixName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1.html#project_name DataOpentelekomcloudCtsTrackerV1#project_name}.
     *
     * @stability stable
     */
    readonly projectName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1.html#region DataOpentelekomcloudCtsTrackerV1#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1.html#status DataOpentelekomcloudCtsTrackerV1#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1.html#tracker_name DataOpentelekomcloudCtsTrackerV1#tracker_name}.
     *
     * @stability stable
     */
    readonly trackerName?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1.html opentelekomcloud_cts_tracker_v1}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudCtsTrackerV1 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1.html opentelekomcloud_cts_tracker_v1} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudCtsTrackerV1Config);
    private _bucketName?;
    /**
     * @stability stable
     */
    get bucketName(): string | undefined;
    /**
     * @stability stable
     */
    set bucketName(value: string | undefined);
    /**
     * @stability stable
     */
    resetBucketName(): void;
    /**
     * @stability stable
     */
    get bucketNameInput(): string | undefined;
    private _filePrefixName?;
    /**
     * @stability stable
     */
    get filePrefixName(): string | undefined;
    /**
     * @stability stable
     */
    set filePrefixName(value: string | undefined);
    /**
     * @stability stable
     */
    resetFilePrefixName(): void;
    /**
     * @stability stable
     */
    get filePrefixNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get isSendAllKeyOperation(): any;
    /**
     * @stability stable
     */
    get isSupportSmn(): any;
    /**
     * @stability stable
     */
    get needNotifyUserList(): string[];
    /**
     * @stability stable
     */
    get operations(): string[];
    private _projectName?;
    /**
     * @stability stable
     */
    get projectName(): string | undefined;
    /**
     * @stability stable
     */
    set projectName(value: string | undefined);
    /**
     * @stability stable
     */
    resetProjectName(): void;
    /**
     * @stability stable
     */
    get projectNameInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string | undefined;
    /**
     * @stability stable
     */
    set region(value: string | undefined);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string | undefined;
    /**
     * @stability stable
     */
    set status(value: string | undefined);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    /**
     * @stability stable
     */
    get topicId(): string;
    private _trackerName?;
    /**
     * @stability stable
     */
    get trackerName(): string | undefined;
    /**
     * @stability stable
     */
    set trackerName(value: string | undefined);
    /**
     * @stability stable
     */
    resetTrackerName(): void;
    /**
     * @stability stable
     */
    get trackerNameInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
