import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudDcsAzV1Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1.html#code DataOpentelekomcloudDcsAzV1#code}.
     *
     * @stability stable
     */
    readonly code?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1.html#name DataOpentelekomcloudDcsAzV1#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1.html#port DataOpentelekomcloudDcsAzV1#port}.
     *
     * @stability stable
     */
    readonly port?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1.html opentelekomcloud_dcs_az_v1}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudDcsAzV1 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1.html opentelekomcloud_dcs_az_v1} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudDcsAzV1Config);
    private _code?;
    /**
     * @stability stable
     */
    get code(): string | undefined;
    /**
     * @stability stable
     */
    set code(value: string | undefined);
    /**
     * @stability stable
     */
    resetCode(): void;
    /**
     * @stability stable
     */
    get codeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string | undefined;
    /**
     * @stability stable
     */
    set name(value: string | undefined);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): string | undefined;
    /**
     * @stability stable
     */
    set port(value: string | undefined);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
