import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudDcsProductV1Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1.html#spec_code DataOpentelekomcloudDcsProductV1#spec_code}.
     *
     * @stability stable
     */
    readonly specCode?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1.html opentelekomcloud_dcs_product_v1}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudDcsProductV1 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1.html opentelekomcloud_dcs_product_v1} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudDcsProductV1Config);
    /**
     * @stability stable
     */
    get id(): string;
    private _specCode?;
    /**
     * @stability stable
     */
    get specCode(): string | undefined;
    /**
     * @stability stable
     */
    set specCode(value: string | undefined);
    /**
     * @stability stable
     */
    resetSpecCode(): void;
    /**
     * @stability stable
     */
    get specCodeInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
