import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudLbListenerV3Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#client_ca_tls_container_ref DataOpentelekomcloudLbListenerV3#client_ca_tls_container_ref}.
     *
     * @stability stable
     */
    readonly clientCaTlsContainerRef?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#client_timeout DataOpentelekomcloudLbListenerV3#client_timeout}.
     *
     * @stability stable
     */
    readonly clientTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#default_pool_id DataOpentelekomcloudLbListenerV3#default_pool_id}.
     *
     * @stability stable
     */
    readonly defaultPoolId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#default_tls_container_ref DataOpentelekomcloudLbListenerV3#default_tls_container_ref}.
     *
     * @stability stable
     */
    readonly defaultTlsContainerRef?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#description DataOpentelekomcloudLbListenerV3#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#id DataOpentelekomcloudLbListenerV3#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#keep_alive_timeout DataOpentelekomcloudLbListenerV3#keep_alive_timeout}.
     *
     * @stability stable
     */
    readonly keepAliveTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#loadbalancer_id DataOpentelekomcloudLbListenerV3#loadbalancer_id}.
     *
     * @stability stable
     */
    readonly loadbalancerId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#member_address DataOpentelekomcloudLbListenerV3#member_address}.
     *
     * @stability stable
     */
    readonly memberAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#member_device_id DataOpentelekomcloudLbListenerV3#member_device_id}.
     *
     * @stability stable
     */
    readonly memberDeviceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#member_timeout DataOpentelekomcloudLbListenerV3#member_timeout}.
     *
     * @stability stable
     */
    readonly memberTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#name DataOpentelekomcloudLbListenerV3#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#protocol DataOpentelekomcloudLbListenerV3#protocol}.
     *
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#protocol_port DataOpentelekomcloudLbListenerV3#protocol_port}.
     *
     * @stability stable
     */
    readonly protocolPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html#tls_ciphers_policy DataOpentelekomcloudLbListenerV3#tls_ciphers_policy}.
     *
     * @stability stable
     */
    readonly tlsCiphersPolicy?: string;
}
/**
 * @stability stable
 */
export declare class DataOpentelekomcloudLbListenerV3InsertHeaders extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get forwardElbIp(): any;
    /**
     * @stability stable
     */
    get forwardedForPort(): any;
    /**
     * @stability stable
     */
    get forwardedHost(): any;
    /**
     * @stability stable
     */
    get forwardedPort(): any;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html opentelekomcloud_lb_listener_v3}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudLbListenerV3 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3.html opentelekomcloud_lb_listener_v3} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudLbListenerV3Config);
    /**
     * @stability stable
     */
    get adminStateUp(): any;
    private _clientCaTlsContainerRef?;
    /**
     * @stability stable
     */
    get clientCaTlsContainerRef(): string | undefined;
    /**
     * @stability stable
     */
    set clientCaTlsContainerRef(value: string | undefined);
    /**
     * @stability stable
     */
    resetClientCaTlsContainerRef(): void;
    /**
     * @stability stable
     */
    get clientCaTlsContainerRefInput(): string | undefined;
    private _clientTimeout?;
    /**
     * @stability stable
     */
    get clientTimeout(): number | undefined;
    /**
     * @stability stable
     */
    set clientTimeout(value: number | undefined);
    /**
     * @stability stable
     */
    resetClientTimeout(): void;
    /**
     * @stability stable
     */
    get clientTimeoutInput(): number | undefined;
    /**
     * @stability stable
     */
    get createdAt(): string;
    private _defaultPoolId?;
    /**
     * @stability stable
     */
    get defaultPoolId(): string | undefined;
    /**
     * @stability stable
     */
    set defaultPoolId(value: string | undefined);
    /**
     * @stability stable
     */
    resetDefaultPoolId(): void;
    /**
     * @stability stable
     */
    get defaultPoolIdInput(): string | undefined;
    private _defaultTlsContainerRef?;
    /**
     * @stability stable
     */
    get defaultTlsContainerRef(): string | undefined;
    /**
     * @stability stable
     */
    set defaultTlsContainerRef(value: string | undefined);
    /**
     * @stability stable
     */
    resetDefaultTlsContainerRef(): void;
    /**
     * @stability stable
     */
    get defaultTlsContainerRefInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string | undefined;
    /**
     * @stability stable
     */
    set description(value: string | undefined);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get http2Enable(): any;
    private _id?;
    /**
     * @stability stable
     */
    get id(): string | undefined;
    /**
     * @stability stable
     */
    set id(value: string | undefined);
    /**
     * @stability stable
     */
    resetId(): void;
    /**
     * @stability stable
     */
    get idInput(): string | undefined;
    /**
     * @stability stable
     */
    insertHeaders(index: string): DataOpentelekomcloudLbListenerV3InsertHeaders;
    private _keepAliveTimeout?;
    /**
     * @stability stable
     */
    get keepAliveTimeout(): number | undefined;
    /**
     * @stability stable
     */
    set keepAliveTimeout(value: number | undefined);
    /**
     * @stability stable
     */
    resetKeepAliveTimeout(): void;
    /**
     * @stability stable
     */
    get keepAliveTimeoutInput(): number | undefined;
    private _loadbalancerId?;
    /**
     * @stability stable
     */
    get loadbalancerId(): string | undefined;
    /**
     * @stability stable
     */
    set loadbalancerId(value: string | undefined);
    /**
     * @stability stable
     */
    resetLoadbalancerId(): void;
    /**
     * @stability stable
     */
    get loadbalancerIdInput(): string | undefined;
    private _memberAddress?;
    /**
     * @stability stable
     */
    get memberAddress(): string | undefined;
    /**
     * @stability stable
     */
    set memberAddress(value: string | undefined);
    /**
     * @stability stable
     */
    resetMemberAddress(): void;
    /**
     * @stability stable
     */
    get memberAddressInput(): string | undefined;
    private _memberDeviceId?;
    /**
     * @stability stable
     */
    get memberDeviceId(): string | undefined;
    /**
     * @stability stable
     */
    set memberDeviceId(value: string | undefined);
    /**
     * @stability stable
     */
    resetMemberDeviceId(): void;
    /**
     * @stability stable
     */
    get memberDeviceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get memberRetryEnable(): any;
    private _memberTimeout?;
    /**
     * @stability stable
     */
    get memberTimeout(): number | undefined;
    /**
     * @stability stable
     */
    set memberTimeout(value: number | undefined);
    /**
     * @stability stable
     */
    resetMemberTimeout(): void;
    /**
     * @stability stable
     */
    get memberTimeoutInput(): number | undefined;
    /**
     * @stability stable
     */
    get memoryRetryEnable(): any;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string | undefined;
    /**
     * @stability stable
     */
    set name(value: string | undefined);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get projectId(): string;
    private _protocol?;
    /**
     * @stability stable
     */
    get protocol(): string | undefined;
    /**
     * @stability stable
     */
    set protocol(value: string | undefined);
    /**
     * @stability stable
     */
    resetProtocol(): void;
    /**
     * @stability stable
     */
    get protocolInput(): string | undefined;
    private _protocolPort?;
    /**
     * @stability stable
     */
    get protocolPort(): number | undefined;
    /**
     * @stability stable
     */
    set protocolPort(value: number | undefined);
    /**
     * @stability stable
     */
    resetProtocolPort(): void;
    /**
     * @stability stable
     */
    get protocolPortInput(): number | undefined;
    /**
     * @stability stable
     */
    get sniContainerRefs(): string[];
    /**
     * @stability stable
     */
    tags(key: string): string;
    private _tlsCiphersPolicy?;
    /**
     * @stability stable
     */
    get tlsCiphersPolicy(): string | undefined;
    /**
     * @stability stable
     */
    set tlsCiphersPolicy(value: string | undefined);
    /**
     * @stability stable
     */
    resetTlsCiphersPolicy(): void;
    /**
     * @stability stable
     */
    get tlsCiphersPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get updatedAt(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
