import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudRtsSoftwareDeploymentV1Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1.html#action DataOpentelekomcloudRtsSoftwareDeploymentV1#action}.
     *
     * @stability stable
     */
    readonly action?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1.html#config_id DataOpentelekomcloudRtsSoftwareDeploymentV1#config_id}.
     *
     * @stability stable
     */
    readonly configId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1.html#id DataOpentelekomcloudRtsSoftwareDeploymentV1#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1.html#region DataOpentelekomcloudRtsSoftwareDeploymentV1#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1.html#server_id DataOpentelekomcloudRtsSoftwareDeploymentV1#server_id}.
     *
     * @stability stable
     */
    readonly serverId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1.html#status DataOpentelekomcloudRtsSoftwareDeploymentV1#status}.
     *
     * @stability stable
     */
    readonly status?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1.html opentelekomcloud_rts_software_deployment_v1}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudRtsSoftwareDeploymentV1 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1.html opentelekomcloud_rts_software_deployment_v1} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudRtsSoftwareDeploymentV1Config);
    private _action?;
    /**
     * @stability stable
     */
    get action(): string | undefined;
    /**
     * @stability stable
     */
    set action(value: string | undefined);
    /**
     * @stability stable
     */
    resetAction(): void;
    /**
     * @stability stable
     */
    get actionInput(): string | undefined;
    private _configId?;
    /**
     * @stability stable
     */
    get configId(): string | undefined;
    /**
     * @stability stable
     */
    set configId(value: string | undefined);
    /**
     * @stability stable
     */
    resetConfigId(): void;
    /**
     * @stability stable
     */
    get configIdInput(): string | undefined;
    private _id?;
    /**
     * @stability stable
     */
    get id(): string | undefined;
    /**
     * @stability stable
     */
    set id(value: string | undefined);
    /**
     * @stability stable
     */
    resetId(): void;
    /**
     * @stability stable
     */
    get idInput(): string | undefined;
    /**
     * @stability stable
     */
    inputValues(key: string): string;
    /**
     * @stability stable
     */
    outputValues(key: string): string;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string | undefined;
    /**
     * @stability stable
     */
    set region(value: string | undefined);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _serverId?;
    /**
     * @stability stable
     */
    get serverId(): string | undefined;
    /**
     * @stability stable
     */
    set serverId(value: string | undefined);
    /**
     * @stability stable
     */
    resetServerId(): void;
    /**
     * @stability stable
     */
    get serverIdInput(): string | undefined;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string | undefined;
    /**
     * @stability stable
     */
    set status(value: string | undefined);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    /**
     * @stability stable
     */
    get statusReason(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
