import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudVbsBackupPolicyV2Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html#id DataOpentelekomcloudVbsBackupPolicyV2#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html#name DataOpentelekomcloudVbsBackupPolicyV2#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html#policy_resource_count DataOpentelekomcloudVbsBackupPolicyV2#policy_resource_count}.
     *
     * @stability stable
     */
    readonly policyResourceCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html#region DataOpentelekomcloudVbsBackupPolicyV2#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html#status DataOpentelekomcloudVbsBackupPolicyV2#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * filter_tags block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html#filter_tags DataOpentelekomcloudVbsBackupPolicyV2#filter_tags}
     *
     * @stability stable
     */
    readonly filterTags?: DataOpentelekomcloudVbsBackupPolicyV2FilterTags[];
}
/**
 * @stability stable
 */
export declare class DataOpentelekomcloudVbsBackupPolicyV2Tags extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    get value(): string;
}
/**
 * @stability stable
 */
export interface DataOpentelekomcloudVbsBackupPolicyV2FilterTags {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html#key DataOpentelekomcloudVbsBackupPolicyV2#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html#values DataOpentelekomcloudVbsBackupPolicyV2#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html opentelekomcloud_vbs_backup_policy_v2}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudVbsBackupPolicyV2 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2.html opentelekomcloud_vbs_backup_policy_v2} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudVbsBackupPolicyV2Config);
    /**
     * @stability stable
     */
    get frequency(): number;
    private _id?;
    /**
     * @stability stable
     */
    get id(): string | undefined;
    /**
     * @stability stable
     */
    set id(value: string | undefined);
    /**
     * @stability stable
     */
    resetId(): void;
    /**
     * @stability stable
     */
    get idInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string | undefined;
    /**
     * @stability stable
     */
    set name(value: string | undefined);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _policyResourceCount?;
    /**
     * @stability stable
     */
    get policyResourceCount(): number | undefined;
    /**
     * @stability stable
     */
    set policyResourceCount(value: number | undefined);
    /**
     * @stability stable
     */
    resetPolicyResourceCount(): void;
    /**
     * @stability stable
     */
    get policyResourceCountInput(): number | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string | undefined;
    /**
     * @stability stable
     */
    set region(value: string | undefined);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    /**
     * @stability stable
     */
    get remainFirstBackup(): string;
    /**
     * @stability stable
     */
    get rententionNum(): number;
    /**
     * @stability stable
     */
    get startTime(): string;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string | undefined;
    /**
     * @stability stable
     */
    set status(value: string | undefined);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    /**
     * @stability stable
     */
    tags(index: string): DataOpentelekomcloudVbsBackupPolicyV2Tags;
    private _filterTags?;
    /**
     * @stability stable
     */
    get filterTags(): DataOpentelekomcloudVbsBackupPolicyV2FilterTags[] | undefined;
    /**
     * @stability stable
     */
    set filterTags(value: DataOpentelekomcloudVbsBackupPolicyV2FilterTags[] | undefined);
    /**
     * @stability stable
     */
    resetFilterTags(): void;
    /**
     * @stability stable
     */
    get filterTagsInput(): DataOpentelekomcloudVbsBackupPolicyV2FilterTags[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
